<template>
	<div>
		<span class="screen-reader-only">{{ `${rating} star${rating > 1 ? 's' : ''}` }}</span>
		<div :class="$style.stars" aria-hidden="true">
			<div :class="$style.starsInner" :style="{ width: `${stars}%` }" />
		</div>
	</div>
</template>

<script>
export default {
	props: {
		rating: {
			type: Number,
			default: 0,
		},
	},

	computed: {
		stars() {
			// 208px = 5 stars * 32px + 4 * 12px spacing
			// but we're taking 6px for the empty outline
			const { rating } = this;
			const star = 20 / 208;
			const spacing = 12 / 208;
			const outline = 6 / 208;
			const outlines = Math.floor(rating) * 2 + (rating % 1 ? 1 : 0);
			return (rating * star + spacing * Math.floor(rating) + outline * outlines) * 100;
		},
	},
};
</script>

<style lang="scss" module>
@import '@design';

.stars {
	width: 104px;
	height: 1.6rem;
	background-image: url('~assets/images/stars-empty.png');
	background-repeat: no-repeat;
	background-size: 104px 16px;
}

.starsInner {
	height: 100%;
	background-image: url('~assets/images/stars-filled.png');
	background-repeat: no-repeat;
	background-size: 104px 16px;
}
</style>
